<?php
/**
 * Branko Ajzele, http://activecodeline.com
 *
 * NOTICE OF LICENSE
 *
 * @category    ActiveCodeline
 * @package     ActiveCodeline_Widget
 * @copyright   Copyright (c) 2009 Branko Ajzele
 * @license     http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */
class ActiveCodeline_WidgetMiniFeedReader_Block_Output
extends Mage_Core_Block_Abstract
implements Mage_Widget_Block_Interface
{
    protected function _toHtml()
    {
        $html = '';

        $feed_url = $this->getData('feed_url');
        $show_max_body_chars = (int)$this->getData('show_max_body_chars');
        $show_total_of_n_feeds = (int)$this->getData('show_total_of_n_feeds');
        $feed_box_title = (string)$this->getData('feed_box_title');
        $strip_tags = true;

        $channel = new Zend_Feed_Rss($feed_url);
        //var_dump($channel);

        if($channel instanceof Zend_Feed_Rss) {
            
            $html .= '<div class="ac-mini-feed-reader">';

            $counter = 0;

            if($channel->count() > 0) {
                if(!empty ($feed_box_title)) {
                    $html .= '<h3>'.$feed_box_title.'</h3>';
                }

                $html .= '<ul>';
                foreach ($channel as $item) {
                    $html .= '<li>';
                    $html .= '<a href="'.$item->link.'" target="_blank">'.$item->title.'</a>';
                    if($show_max_body_chars > 0) {
                        $description = substr($item->description, 0, $show_max_body_chars).'...';
                        if($strip_tags) {
                            $description = strip_tags($description);
                        }
                        $html .= '<p>'.$description.'</p>';
                    }
                    $html .= '</li>';

                    $counter++;
                    if($counter == $show_total_of_n_feeds) { break; }
                }
                $html .= '</ul>';
            }
            $html .= '</div>';
        }

        return $html;
    }
}